# © 2022 Le Filament (<http://www.le-filament.com>)
# License AGPL-3.0 or later (http://www.gnu.org/licenses/agpl.html).

from odoo import fields, models


class ScopPartner(models.Model):
    _inherit = "res.partner"

    date_bureau_validation = fields.Date(
        string="Date du bureau de validation",
        compute="_compute_date_bureau_validation",
    )

    # ------------------------------------------------------
    # Compute
    # ------------------------------------------------------
    def _compute_date_bureau_validation(self):
        """
        Date bureau adhesion is last instance type adhesion attached to partner
        :return:
        """
        for r in self:
            r.date_bureau_validation = None
            instance_adhesion_ids = r.instance_ids.filtered(
                "is_type_membership"
            ).sorted("date_start")
            if instance_adhesion_ids:
                r.date_bureau_validation = instance_adhesion_ids[-1].date_start.date()

    # ------------------------------------------------------
    # Business method
    # ------------------------------------------------------
